Subject: Re: v4-mapped-v6 addresses with SCTP Sockets API.

From: "Randall Stewart (cisco)" <[email-masked]>
Date: Wed, 20 Nov 2002 18:53:00 -0600

Jon Grimm wrote:

>Hi Randy,
>
>Spec'ing a mechanism to set/get behavior seems reasonable, though the
>choice of default is arguable given RFC 2553 expectations.  
>  
>
arguably one could make the default be that you get a mapped address... 
but as
you point out reality does byte :>

We call the option:

SCTP_I_WANT_MAPPED_V4_ADDR   

Somewhat appropriate I think :>.. I can add it to the draft if
folks think it is worthwhile and then we can debate if it should
be on by default or off :>

Reality does tend to show that users don't want to take and write
there app to convert the v4 addresses into v6 mapped.. and then
handle them.. I think your assessment that there are a few v4 only
apps or ones that at times do v4 only is probably the right assesment..

It might be a wonderful world where v6 was deployed but it is just not
reality yet...

R

>OTOH, from your porting experiences it doesn't sound like application
>are really taking advantage of v4-mapped-v6 addresses in a way to
>consolidate their code.  Is this likely due to the application still
>needing to support PF_INET only systems?  That darn reality just keeps
>creeping in, don't it? 
>
>I'll watch for a mechanism (I'm assuming sockopt here.) forthcoming.  A
>recvmsg flag seems overkill as an application would surely just want one
>addressing format.   
>
>Best Regards,
>Jon
>
>
>
>"Randall Stewart (cisco)" wrote:
>  
>
>>Jon:
>>
>>Some comments from a boring bof :->
>>
>>Jon Grimm wrote:
>>
>>    
>>
>
><much clipped>
>
>  
>
>>I don't think that it is NOT supported... but implied as to the way you
>>want to do it..
>>
>>In our implementation:
>>
>>- A IPv4 address can be sent to a IPv6 address (assuming you have not
>>  set the V6_ONLY flag on the socket). Or if you prefer you can send to
>>  a mapped V4 address and the stack will convert it to V4...
>>
>>- In reading an address... if someone sends to you from an IPv4 address
>>  you will read from your IPv6 socket one of two things... either a true
>>  IPv4 address OR a IPv4 mapped address. This is dependant on a flag
>>  that we put in the API. The default is you get IPv4 addresses as IPv4
>>addresses...even
>>    
>>
>
>  
>
>>Right now the document leaves it open.. but we may want to put
>>some minor text in that specifies that a applicaiton should
>>always have the ability to assure all v4 addresses are mapped if
>>we have a v6 socket...
>>
>>That way an app COULD be written to deal with v6 only address styles **
>>a poor
>>design in my mind ** but we can allow bad designs too :-)
>>
>>R
>>
>>
>>    
>>
>
>  
>

-- 
Randall R. Stewart
ITD
Cisco Systems Inc.
[email-masked] 815-342-5222(cell) or 815-477-2127(office)